=== debian/changelog ===
optee-client (4.7.0-1) unstable; urgency=low

  * New upstream version 4.7.0

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 13 Aug 2025 13:35:19 +0100
