=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# GitHub hosted projects
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%optee-client-$1.tar.gz%" \
   https://github.com/OP-TEE/optee_client/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
