=== debian/changelog ===
optee-client (4.8.0-1) unstable; urgency=low

  * New upstream version 4.8.0

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Sun, 30 Nov 2025 15:54:35 +0000
